#pragma once
#include<fstream>
#include<iomanip>
#include<iostream>
#include<string>
#include<vector>
#include<windows.h>
#include"Student.h"
#include"Exam.h"
using namespace std;
class Manager {
public:
	Manager();

	void mainLoop();
	void goBack();
	void centeredPrint(const string& content);
	Student* searchByNo(long long int studentNo);
	//status 0
	void welcomePage();
	//status 1                                                         
	void stuPage();
	//status 11
	void stuDspPage();
	//status 12
	void stuAddPage();
	//status 13
	void stuSearchPage();
	//status 14
	void stuEdtRmvPage();
	//status 15
	void stuExportPage();
	//status 16
	void stuImportPage();
	//status 2
	void examPage();
	//status 21
	void examAddPage();
	//status 22
	void examChoosePage();
	//status 23
	void examSubPage();
	//status 231
	void examViewPage();
	//status 232
	void examExportPage();
	//status 233
	void examAddRowPage();
	//status 234
	void examDelRowPage();
	//status 235
	void examNamePage();
	//status 236
	void examImportPage();
	//status 237
	void examRmvPage();
	//status 3
	void stuPfmPage();

	virtual ~Manager();
private:
	int status = 0;
	int ExamNum = 0, StudentNum = 0;
	vector<Student> Students;
	vector<std::shared_ptr<Exam>> Exams;
	vector<std::shared_ptr<Exam>>::iterator currentExam = Exams.begin();
};