#include"Exceptions.h"
BaseException::BaseException(const string& message) {
	this->message = message;
}
string InputError::what() const {
	return message;
}
InputError::InputError(const string& message) :BaseException(message) {
	
}
string FileError::what() const {
	return message;
}
FileError::FileError(const string& message) :BaseException(message) {

}
string IndexError::what() const {
	return message;
}
IndexError::IndexError(const string& message) :BaseException(message) {

}
