#pragma once
#include<fstream>
#include<iomanip>
#include<iostream>
#include<string>
#include<vector>
using namespace std;
class BaseException {
public:
	BaseException(const string& message);

	virtual string what() const=0;
	string message;
};
class InputError :public BaseException {
public:
	InputError(const string& message);

	virtual string what() const;
};
class FileError :public BaseException {
public:
	FileError(const string& message);

	virtual string what() const;
};
class IndexError :public BaseException {
public:
	IndexError(const string& message);

	virtual string what() const;
};